%Program symulujcy perceptron do zadania aproksymacji funkcji.
%Program skopiuj do swojego katalogu i nazwij perceptron_apr.m.
%Program wywouje sie z linii polece podajc numer sekcji, np.
%perceptron_apr(1.1).

function perceptron_apr(nr_gr)
%nr_gr - numer sekcji np. 1.1, 1.2, ...

rk=2014; %uwaga! tutaj wpisz aktualny rok kalendarzowy 

%zbir uczcy
lp_trn=20; %liczba punktw
[x_trn,t_trn]=gener_xy(nr_gr,lp_trn,1,rk); %punkty uczce

%zbir testowy
lp_tst=100; %liczba punktw
[x_tst,t_tst]=gener_xy(nr_gr,lp_tst,2,rk); %punkty testowe

l_neur=1; %liczba neuronw w warstwie ukrytej
%trening sieci
net=newff([-1 1],[l_neur 1],{'tansig','tansig'},'trainscg'); %utworzenie sieci; pierwszy argument reprezentuje zakresy danych wejciowych,
%drugi - liczb neuronw w warstwie ukrytej i wyjciowej, trzeci - typy funkcji aktywacji w tych warstwach, czwarty - metod uczenia sieci
%funkcja zwraca obiekt sieci net
net.trainParam.epochs = 1000; %liczba epok uczenia 
[net,tr]=train(net,x_trn,t_trn); %trening sieci

%symulacja nauczonej sieci dla zbioru uczcego
yy=sim(net,x_trn);
b_trn=abs(yy-t_trn)/2*100; %bdy aproksymacji w procentach
b_trnm=mean(b_trn) %bd redni

%symulacja nauczonej sieci dla zbioru testowego
yy=sim(net,x_tst);
b_tst=abs(yy-t_tst)/2*100;
b_tstm=mean(b_tst)

% wykres bdw
x1=-1:0.01:1;
r=2;
y1=f_aproksymowana(x1,nr_gr,r,rk); 
yy=sim(net,x1);
figure(2);
plot(x1,yy,'r');
b_y=(yy-y1)/2*100;
xlabel('x'); ylabel('y');
figure(3);
plot(x1,b_y);
xlabel('x'); ylabel('blad wzgledny, %');
hold on;

%___funkcje pomocnicze_____________________________________________________

%generator danych do aproksymacji y=f(x)
function [x,y]=gener_xy(nr_gr,lp,trn_tst,rk)
%nr_gr - numer podgrupy np. 1.1, 1.2, ...
%lp - liczba wygenerowanych punktw
%trn_tst = 1 dla zbioru treningowego lub 2 dla zbioru testowego
%rk - rok kalendarzowy
figure(2);

r=2;
x=-1:0.01:1;
y=f_aproksymowana(x,nr_gr,r,rk);
plot(x,y,'--');
hold on;

if trn_tst==1 rand('state',sum(nr_gr*10));
elseif trn_tst==2 rand('state',sum(nr_gr*50)); end;
x=rand(1,lp)*2-1;
y=f_aproksymowana(x,nr_gr,r,rk);
if trn_tst==1 plot(x,y,'o');
elseif trn_tst==2 plot(x,y,'x'); end;


%funkcja aproksymowana
function [y]=f_aproksymowana(x,nr_gr,r,rk)
rand('state',nr_gr*rk);
q=1+5*rand;
y=sin(cos(x*pi)*pi+1/(r*q)*cos((x+r*q)*pi*q)*pi);
